Wt: Wt::WAnimation Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions
Wt::WAnimation Class Reference

A value class that defines a transition effect. More...

`#include <Wt/WAnimation>`

List of all members.

## Public Types
enum | AnimationEffect { SlideInFromLeft = 0x1, SlideInFromRight = 0x2, SlideInFromBottom = 0x3, SlideInFromTop = 0x4, Pop = 0x5, Fade = 0x100 }
| An enumeration describing an animation effect. More...
enum | TimingFunction { Ease, Linear, EaseIn, EaseOut, EaseInOut, CubicBezier }
| A timing function. More...
## Public Member Functions
| WAnimation ()
| Default constructor.
| WAnimation (WFlags< AnimationEffect > effects, TimingFunction timing=Linear, int duration=250)
| Creates an animation.
void | setEffects (WFlags< AnimationEffect > effects)
| Sets the animation effects.
WFlags< AnimationEffect > | effects () const
| Returns animation effects.
bool | operator== (const WAnimation &other) const
| Comparison operator.
bool | operator!= (const WAnimation &other) const
| Comparison operator.
void | setDuration (int msecs)
| Sets the duration.
int | duration () const
| Returns the duration.
void | setTimingFunction (TimingFunction function)
| Sets a timing function.
TimingFunction | timingFunction () const
| Returns the timing function.
bool | empty () const
| Returns whether the animation is empty.

## Detailed Description

A value class that defines a transition effect.

This class defines an animation used as a transition to show or hide a widget.

The animation can be defined as a motion effect (e.g. sliding in or out), optionally combined with a fade effect. A timing function defines how the effects(s) are animated during the total duration of the animation.

See also:
  WWidget::animateShow(), WWidget::animateHide(), WWidget::setHidden()

## Member Enumeration Documentation

enum Wt::WAnimation::AnimationEffect

An enumeration describing an animation effect.

An animation effect can be the combination of a motion and an optional fade effect, e.g:

      SlideInFromRight
      SlideInFromTop | Fade

You can specify only one motion effect.

See also:
  setEffects()

Enumerator:

  SlideInFromLeft | Slides right to show, left to hide.
  SlideInFromRight | Slides left to show, right to hide.
  SlideInFromBottom | Slides up to show, down to hide.
  SlideInFromTop | Slides down to show, up to hide.
  Pop | Pops up to show, pops away to hide.
  Fade | Fade effect.

enum Wt::WAnimation::TimingFunction

A timing function.

The timing function defines how the animation effects are animated during the total duration of the animation.

Enumerator:

  Ease | Slow start and slow finish.
  Linear | Linear throughout.
  EaseIn | Slow start.
  EaseOut | Slow finish.
  EaseInOut | Slow start and even slower finish.
  CubicBezier | (Currently unsupported)

## Constructor & Destructor Documentation

Wt::WAnimation::WAnimation | ( |  | ) |

Default constructor.

Creates an animation that actually represent no animation. (effects() == 0).

Wt::WAnimation::WAnimation | ( | WFlags< AnimationEffect > | effects,
|  | TimingFunction | timing = `Linear`,
|  | int | duration = `250`
| ) |  |

Creates an animation.

An animation is created with given effects, timing and duration.

## Member Function Documentation

int Wt::WAnimation::duration | ( |  | ) | const

Returns the duration.

See also:
  setDuration()

WFlags<AnimationEffect> Wt::WAnimation::effects | ( |  | ) | const

Returns animation effects.

See also:
  setEffects()

bool Wt::WAnimation::empty | ( |  | ) | const

Returns whether the animation is empty.

An animation is empty (meaning the transition is instant), if the duration is 0, or if no effects are defined.

bool Wt::WAnimation::operator!= | ( | const WAnimation & | other | ) | const

Comparison operator.

Returns `true` if the transitions are different.

bool Wt::WAnimation::operator== | ( | const WAnimation & | other | ) | const

Comparison operator.

Returns `true` if the transitions are exactly the same.

void Wt::WAnimation::setDuration | ( | int | msecs | ) |

Sets the duration.

The default animation duration is 250 ms.

See also:
  duration()

void Wt::WAnimation::setEffects | ( | WFlags< AnimationEffect > | effects | ) |

Sets the animation effects.

A motion effect (SlideInFromLeft, SlideInFromRight, SlideInFromBottom, SlideInFromTop or Pop) can be combined with a fade effect (Fade).

When effects are 0, the animation does not actually specify an animation, but instead an instant transition.

void Wt::WAnimation::setTimingFunction | ( | TimingFunction | function | ) |

Sets a timing function.

The default timinig function is WAnimation::Linear.

TimingFunction Wt::WAnimation::timingFunction | ( |  | ) | const

Returns the timing function.

See also:
  setTimingFunction()

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator